// Copyright (C) 2010 Julien VAUBOURG
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// Author  : http://julien.vaubourg.com
// SpinkBB : http://spinkbb.jsand.net
// Forums  : http://CtrlAltSuppr.com

Langues = {

	/*
		é \351
		î \356
		à \340
		ç \347
		« \253
		è \350
		â \342
		ê \352

		http://www.pjb.com.au/comp/diacritics.html
	*/

	get: function(txt) {
		return (Outils.isset(Langues[Parametres.langue]) && Outils.isset(Langues[Parametres.langue][txt])) ? Langues[Parametres.langue][txt] : txt;
	},

	fr: true, // Pour la récupération des langues

	en: {
		// Avertissements
		"Les \351v\351nements ont d\351j\340 \351t\351 affect\351s." : "The events have already been affected.",
		"Importation r\351ussie avec succ\350s !" : "Import done  successfully !",
		"Supprimer toutes les modifications ?" : "Delete all the changes ?",
		"Suppression effectu\351e !" : "Remove done !",
		"Attention !\nVous allez perdre toutes les modifications en cours." : "Warning !\nYou will lose all the changes you've done.",
		"Il y a eu un probl\350me lors de l'importation.\nV\351rifiez l'authenticit\351 de votre Spinker." : "There was a problem during the import.\nCheck the authenticity of your Spinker.",
		"Les modifications ont \351t\351 sauvegard\351es." : "The changes have been saved.",
		"Erreur de d\351s\351rialisation !" : "Deserialization error !",
		"Aucune modification \340 enregistrer." : "No changes to save.",
		"Aucune modification \340 supprimer." : "No changes to delete.",
		"Vous devez enregistrer des modifications avant de pouvoir proposer un aper\347u." : "You must save the changes before asking for a preview.",
		"Des modifications n'ont pas \351t\351 enregistr\351es !\nElles ne seront pas visibles sur l'aper\347u si vous ne le fa\356tes pas." : "Some changes have not been saved !\nThey will not be visible on the preview if you do not save them.",
		"SAUVEGARDE AUTOMATIQUE\n(toutes les <X> minutes)\n\nVous pouvez modifier ces param\350tres dans Aide." : "AUTOMATIC SAVE\n(every <X> minutes)\n\nYou can change these parameters in Help.",
		"Session vide ou inexistante." : "Session empty or non-existent.",

		// Propriétés
		"Oui" : "Yes",
		"Non" : "No",		
		"Gras" : "Bold",
		"Italique" : "Italic",
		"Aucun" : "None",
		"Plein" : "Full",
		"Tirets" : "Dashed",
		"Casse initiale" : "Initial case",
		"Majuscules" : "Capitalization",
		"Gauche" : "Left",
		"Centre" : "Middle",
		"Droite" : "Right",
		"Justifi\351" : "Justified",
		"Bordures" : "Borders",
		"Marges int." : "Int. margins",
		"Marges ext." : "Ext. margins",
		"Largeur" : "Width",
		"Alignement" : "Alignment",
		"Couleur de fond" : "Background color",
		"Couleur" : "Color",
		"Format" : "Format",
		"Taille" : "Size",
		"Police" : "Font",
		"Soulign\351" : "Underlined",

		// Libellés
		"D\351placer" : "Move",
		"Fermer" : "Close",
		"Editer le lien" : "Go to edit link",
		"Patientez" : "Wait",
		"Importer" : "Import",
		"Exporter" : "Export",
		"Enregistrer" : "Save",
		"Supprimer" : "Delete",
		"Comment \347a marche ?" : "How to use ?",
		"G\351n\351raliser l'\351l\351ment" : "Widespread element",
		"Navigateur de noeuds" : "Nodes navigator",
		"Importer votre Spinker" : "Import your Spinker",
		"Exporter le Spinker" : "Export your Spinker",
		"Enregistrer les modifications" : "Save changes",
		"Supprimer les modifications" : "Remove changes",
		"Aide et A propos de SpinkBB" : "Help and About SpinkBB",
		"Saisir un nombre ou la valeur auto" : "Enter a number or value auto",
		"Saisir un nombre" : "Enter a number",
		"Suivre le lien": "Follow the link",
		"Editer le style (\351tat fixe)" : "Edit style (fixed state)",
		"Editer le style (\351tat survol\351)" : "Edit style (hover state)",
		"Noeud pr\351c\351demment s\351lectionn\351" : "Node previously selected",
		"Noeud suivant s\351lectionn\351" : "Node following selected",
		"Langage" : "Language",
		"Pr\351c." : "Prev.",
		"Suiv." : "Next",
		"Afficher le splashscreen" : "Show splashscreen",
		"Aper\347u" : "Preview",
		"Jamais" : "Never",
		"heures" : "hours",
		"Afficher un message" : "Display a message",
		"Sauvegarde auto. toutes les :" : "Auto. save every :",

		// Indications
		"S\351lectionnez ci-dessus la port\351e de vos modifications" : "Select above the range  of your changes",
		"Ajoutez le Spinker suivant \340 la fin du fichier <FICHIER> de votre <SCRIPT>." : "Add the following Spinker to the end of the file <FICHIER> your <SCRIPT>.",
		"Vous pourrez le r\351importer dans SpinkBB lorsque vous souhaiterez apporter des modifications." : "You will be able to import it in SpinkBB when you want to make changes.",
		"G\351n\351r\351 sur" : "Generated on",
		"Pour modifier votre style, importez ce spinker dans SpinkBB" : "To change your style, import this Spinker in SpinkBB",
		"Copiez-collez ici votre Spinker et cliquez sur Importer :" : "Copy and paste your Spinker and click Import",
		"Vous n'avez effectu\351 aucune modification sur le style courant !" : "You have made no changes to the current style !",
		"Vos modifications n'ont pas \351t\351 enregistr\351es sur la page.\nPour sauvegarder, cliquez sur Annuler puis Enregistrer en haut \340 droite." : "Your changes have not been recorded on the page.\nTo save, click Cancel then Save at the top right corner.",
		"<strong>Aide :</strong> en haut \340 droite" : "<strong>Help :</strong> top right",
		"Cliquer pour fermer" : "Click to close",
		"Adresse de pr\351visualisation publique de votre Spinker" : "Public address to preview your Spinker",

		// (A propos)
		"Auteur :" : "Author :",
		"SpinkBB est un g\351n\351rateur de code CSS pour <SCRIPT> (et <a href='http://spinkbb.jsand.net'>d'autres</a>)." : "SpinkBB is a CSS code generator for <SCRIPT> (and <a href='http://spinkbb.jsand.net'>others</a>).",
		"Pointez l'\351l\351ment que vous souhaitez modifier puis cliquez dessus" : "Focus on  the item you want to change then click",
		"Modifiez les propri\351t\351s de l\'\351l\351ment gr\342ce au menu qui appara\356t" : "Change the element's properties with the menu that appears",
		"Cliquez sur Exporter, dans la barre du haut" : "Click on Export, in the top bar",
		"Copiez-collez le Spinker propos\351 (le code CSS additionnel) \340 la fin du fichier indiqu\351" : "Copy and paste the proposed Spinker (the additional CSS) at the end of the specified file",
		"Vous pouvez :" : "You can :",
		"Naviguer dans le site (click sur le lien &gt; Editer le lien &gt; Suivre le lien)" : "Navigate through the website (click on the link &gt; Edit  link &gt; Follow the link)",
		"R\351importer votre Spinker pour retoucher votre style" : "Import your Spinker to edit your style",
		"Essayer un livre d'or" : "Try a guestbook",
		"Essayer une newsletter" : "Try a newsletter",
		"nouvelle page" : "new page",
		"Aper\347u d'un style pour PunBB cr\351\351 avec SpinkBB (nouvelle page)" : "Preview of a style for PunBB created with SpinkBB (new page)",
		"D\351marrer maintenant !" : "Start now !",
		"R\351afficher cette aide en cliquant sur <strong>[Comment \347a marche ?]</strong> en haut \340 droite" : "Redisplay this helper by clicking on <strong>[How to use ?]</strong> in the upper right"
	}
};
